package sca.component.java.impl;


import java.util.List;

import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

import dal.DB2Connector;

public class ClaimRegistrationImpl {
	/**
	 * Default constructor.
	 */
	public ClaimRegistrationImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implemention of operation "registerClaimDocument" defined for WSDL port type 
	 * named "interface.RegisterClaim".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject registerClaimDocument(DataObject inClaimDocument) {
		
		DB2Connector connector = null;
		try
		{
			//Save claim document data
			connector = new DB2Connector();
			connector.createConnection();
			int claimDocumentID = connector.saveClaimDocument(inClaimDocument.getDate("date"),inClaimDocument.getInt("personID"));
			DataObject status = inClaimDocument.getDataObject("status");
			int status_id = connector.saveStatus(claimDocumentID,status.getInt("status"),status.getString("description"));
			DataObject damageEvent = inClaimDocument.getDataObject("damage");
			int damageEventID = connector.saveDamageEvent(claimDocumentID,damageEvent.getString("description"),damageEvent.getString("event"));
			List damagesList = (List)damageEvent.get("damages");
			
			//Create ClaimResult BO
			ServiceManager serviceManager = new ServiceManager();
			BOFactory bof = (BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
			DataObject claimResult = bof.create("http://Common/", "ClaimResult");
			claimResult.setInt("claimDocID",claimDocumentID);
			claimResult.setInt("damageeventID",damageEventID);
			
			int damageID = 0;
			for(int i=0;i<damagesList.size();i++)
			{
				DataObject damage = (DataObject)damagesList.get(i);
				damageID = connector.saveDamages(damageEventID,damage.getDouble("amount"),damage.getString("description"),damage.getString("damage"));				
			}
			inClaimDocument.setDataObject("claimresult",claimResult);
			inClaimDocument.setInt("claimDocumentID",claimDocumentID);
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			if(connector != null)
				connector.closeConnection();
		}
		return inClaimDocument;
	}

}