package sca.component.java.impl;

import java.util.List;

import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

import dal.DB2Connector;

public class PersonRegistrationImpl {
	/**
	 * Default constructor.
	 */
	public PersonRegistrationImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implemention of operation "registerUser" defined for WSDL port type 
	 * named "interface.Registration".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject registerUser(DataObject person) {
		
		DB2Connector connector = null;
		try
		{
			// Save person data
			connector = new DB2Connector();
			connector.createConnection();
			int person_id = connector.savePerson(person.getString("egn"),person.getString("name"),person.getString("phone"));
			List addresses = person.getList("address");
			DataObject address = (DataObject)addresses.get(0);
			int address_id = connector.saveAddress(person_id,address.getInt("zip"),address.getString("street"),address.getString("city"));
			List policies = person.getList("insurancepolicy");
			DataObject insurancepolicy = (DataObject)policies.get(0);
			int insurance_id = connector.saveInsurance(person_id,insurancepolicy.getDate("dateFrom"),insurancepolicy.getDate("dateTo"));
			DataObject iptype = insurancepolicy.getDataObject("iptype");
			int iptype_id = connector.saveIPType(insurance_id,iptype.getInt("typeID"),iptype.getString("description"));
			
			// Set IDs
			person.setInt("personID", person_id);
			insurancepolicy.setInt("insurancePolicyID",insurance_id);
			
			// Create result business object
			ServiceManager serviceManager = new ServiceManager();
			BOFactory bof = (BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
			DataObject validationP = null;
			DataObject personRegistrationResult = bof.create("http://Common/", "PersonRegistrationResult");
			personRegistrationResult.setInt("person_id",person_id);
			personRegistrationResult.setInt("policy_id",insurance_id);
			
			System.out.println("--->Person registration complete successful");
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			if(connector != null)
				connector.closeConnection();
		}
		return person;
	}

}