package sca.component.java.impl;

import java.util.ArrayList;
import java.util.List;

import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class PersonValidationImpl {
	/**
	 * Default constructor.
	 */
	public PersonValidationImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implemention of operation "isEGNValid" defined for WSDL port type 
	 * named "interface.PersonValidation".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject isEGNValid(DataObject inPerson) {
		
		String egn = inPerson.getString("egn");
		DataObject personValidation = null;
		ServiceManager serviceManager = new ServiceManager();
		BOFactory bof = (BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
		DataObject validationP = null;
		List validationList = new ArrayList();
		personValidation = inPerson.getDataObject("personvalidation");
		if(egn.length() != 10)
		{
			personValidation.setBoolean("isError",true);			
			validationP = bof.create("http://Common/", "ValidationP");
			validationP.setString("code","Person.egn");
			validationP.setString("description","The lenght of the field is not ten");
			validationList.add(validationP);		
		}
		try
		{
			Long.parseLong(egn);
		}
		catch(Exception ex)
		{
			personValidation.setBoolean("isError",true);
			validationP = bof.create("http://Common/", "ValidationP");
			validationP.setString("code","Person.egn");
			validationP.setString("description","This field should contains numbers only");
			validationList.add(validationP);
		}
		if(validationList.size() > 0)
			personValidation.set("validationp",validationList);
		return inPerson;
	}

}