ALTER TABLE "GIC"."CLAIMDOCUMENT" DROP CONSTRAINT "CD_P_FK";

ALTER TABLE "GIC"."INSURANCEPOLICY" DROP CONSTRAINT "IP_P_FK";

ALTER TABLE "GIC"."DAMAGEEVENT" DROP CONSTRAINT "DE_CD_FK";

ALTER TABLE "GIC"."ADDRESS" DROP CONSTRAINT "ADDRESS_PERSON_FK";

ALTER TABLE "GIC"."IPTYPE" DROP CONSTRAINT "IPT_IP_FK";

ALTER TABLE "GIC"."DAMAGE" DROP CONSTRAINT "D_DE_FK";

ALTER TABLE "GIC"."STATUS" DROP CONSTRAINT "S_CD_FK";

ALTER TABLE "GIC"."DAMAGE" DROP CONSTRAINT "DAMAGE_PK";

ALTER TABLE "GIC"."PERSON" DROP CONSTRAINT "PERSON_PK";

ALTER TABLE "GIC"."STATUS" DROP CONSTRAINT "STATUS_PK";

ALTER TABLE "GIC"."ADDRESS" DROP CONSTRAINT "ADDRESS_PK";

ALTER TABLE "GIC"."INSURANCEPOLICY" DROP CONSTRAINT "INSURANCEPOLICY_PK";

ALTER TABLE "GIC"."CLAIMDOCUMENT" DROP CONSTRAINT "CLAIMDOCUMENT_PK";

ALTER TABLE "GIC"."DAMAGEEVENT" DROP CONSTRAINT "DAMAGEEVENT_PK";

ALTER TABLE "GIC"."IPTYPE" DROP CONSTRAINT "IPTYPE_PK";

DROP TABLE "GIC"."DAMAGE";

DROP TABLE "GIC"."CLAIMDOCUMENT";

DROP TABLE "GIC"."DAMAGEEVENT";

DROP TABLE "GIC"."ADDRESS";

DROP TABLE "GIC"."INSURANCEPOLICY";

DROP TABLE "GIC"."IPTYPE";

DROP TABLE "GIC"."PERSON";

DROP TABLE "GIC"."STATUS";

DROP SCHEMA "GIC" RESTRICT;

CREATE SCHEMA "GIC";

CREATE TABLE "GIC"."CLAIMDOCUMENT" (
		"CLAIMDOCUMENT_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"DATE" DATE NOT NULL,
		"PERSON_ID" INTEGER NOT NULL
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."PERSON" (
		"PERSON_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"EGN" VARCHAR(10),
		"PHONE" VARCHAR(50),
		"NAME" VARCHAR(100)
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."ADDRESS" (
		"ADDRESS_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"PERSON_ID" INTEGER NOT NULL,
		"ZIP" INTEGER NOT NULL,
		"STREET" CHAR(100) NOT NULL,
		"CITY" CHAR(50) NOT NULL
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."INSURANCEPOLICY" (
		"INSURANCEPOLICY_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"PERSON_ID" INTEGER NOT NULL,
		"DATEFROM" DATE NOT NULL,
		"DATETO" DATE NOT NULL
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."DAMAGEEVENT" (
		"DAMAGEEVENT_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"CLAIMDOCUMENT_ID" INTEGER NOT NULL,
		"DESCRIPTION" VARCHAR(200),
		"EVENT" VARCHAR(100)
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."IPTYPE" (
		"IPTYPE_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"INSURANCEPOLICY_ID" INTEGER NOT NULL,
		"TYPEID" INTEGER NOT NULL,
		"DESCRIPTION" VARCHAR(100) NOT NULL
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."STATUS" (
		"STATUS_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"CLAIMDOCUMENT_ID" INTEGER NOT NULL,
		"STATUS" INTEGER NOT NULL,
		"DESCRIPTION" VARCHAR(100)
	)
	DATA CAPTURE NONE ;

CREATE TABLE "GIC"."DAMAGE" (
		"DAMAGE_ID" INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20),
		"DAMAGEEVENT_ID" INTEGER NOT NULL,
		"AMOUNT" DECIMAL(5 , 0) NOT NULL,
		"DESCRIPTION" VARCHAR(200),
		"DAMAGE" VARCHAR(100)
	)
	DATA CAPTURE NONE ;

ALTER TABLE "GIC"."CLAIMDOCUMENT" ADD CONSTRAINT "CLAIMDOCUMENT_PK" PRIMARY KEY ("CLAIMDOCUMENT_ID");

ALTER TABLE "GIC"."PERSON" ADD CONSTRAINT "PERSON_PK" PRIMARY KEY ("PERSON_ID");

ALTER TABLE "GIC"."ADDRESS" ADD CONSTRAINT "ADDRESS_PK" PRIMARY KEY ("ADDRESS_ID");

ALTER TABLE "GIC"."INSURANCEPOLICY" ADD CONSTRAINT "INSURANCEPOLICY_PK" PRIMARY KEY ("INSURANCEPOLICY_ID");

ALTER TABLE "GIC"."DAMAGEEVENT" ADD CONSTRAINT "DAMAGEEVENT_PK" PRIMARY KEY ("DAMAGEEVENT_ID");

ALTER TABLE "GIC"."IPTYPE" ADD CONSTRAINT "IPTYPE_PK" PRIMARY KEY ("IPTYPE_ID");

ALTER TABLE "GIC"."STATUS" ADD CONSTRAINT "STATUS_PK" PRIMARY KEY ("STATUS_ID");

ALTER TABLE "GIC"."DAMAGE" ADD CONSTRAINT "DAMAGE_PK" PRIMARY KEY ("DAMAGE_ID");

ALTER TABLE "GIC"."CLAIMDOCUMENT" ADD CONSTRAINT "CD_P_FK" FOREIGN KEY ("PERSON_ID")
	REFERENCES "GIC"."PERSON" ("PERSON_ID")
	ON DELETE RESTRICT;

ALTER TABLE "GIC"."ADDRESS" ADD CONSTRAINT "ADDRESS_PERSON_FK" FOREIGN KEY ("PERSON_ID")
	REFERENCES "GIC"."PERSON" ("PERSON_ID");

ALTER TABLE "GIC"."INSURANCEPOLICY" ADD CONSTRAINT "IP_P_FK" FOREIGN KEY ("PERSON_ID")
	REFERENCES "GIC"."PERSON" ("PERSON_ID");

ALTER TABLE "GIC"."DAMAGEEVENT" ADD CONSTRAINT "DE_CD_FK" FOREIGN KEY ("CLAIMDOCUMENT_ID")
	REFERENCES "GIC"."CLAIMDOCUMENT" ("CLAIMDOCUMENT_ID");

ALTER TABLE "GIC"."IPTYPE" ADD CONSTRAINT "IPT_IP_FK" FOREIGN KEY ("INSURANCEPOLICY_ID")
	REFERENCES "GIC"."INSURANCEPOLICY" ("INSURANCEPOLICY_ID");

ALTER TABLE "GIC"."STATUS" ADD CONSTRAINT "S_CD_FK" FOREIGN KEY ("CLAIMDOCUMENT_ID")
	REFERENCES "GIC"."CLAIMDOCUMENT" ("CLAIMDOCUMENT_ID");

ALTER TABLE "GIC"."DAMAGE" ADD CONSTRAINT "D_DE_FK" FOREIGN KEY ("DAMAGEEVENT_ID")
	REFERENCES "GIC"."DAMAGEEVENT" ("DAMAGEEVENT_ID");

